'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _icon = require('../icon');

var _icon2 = _interopRequireDefault(_icon);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Button = function (_React$Component) {
  _inherits(Button, _React$Component);

  function Button(props) {
    _classCallCheck(this, Button);

    return _possibleConstructorReturn(this, _React$Component.call(this, props));
  }

  Button.prototype.render = function render() {
    var _classNames;

    var _props = this.props,
        htmlType = _props.htmlType,
        type = _props.type,
        disabled = _props.disabled,
        size = _props.size,
        shape = _props.shape,
        ghost = _props.ghost,
        icon = _props.icon,
        className = _props.className,
        others = _objectWithoutProperties(_props, ['htmlType', 'type', 'disabled', 'size', 'shape', 'ghost', 'icon', 'className']);

    return _react2.default.createElement(
      'button',
      _extends({
        className: (0, _classnames2.default)('dh-btn', (_classNames = {}, _classNames['dh-btn-' + type] = type, _classNames['dh-btn-' + size] = size, _classNames['dh-btn-' + shape] = shape, _classNames['dh-btn-background-ghost'] = ghost, _classNames[className] = className, _classNames)),
        disabled: disabled,
        'data-ghost': ghost
      }, others, {
        type: htmlType
      }),
      icon && !shape ? _react2.default.createElement(
        'span',
        { className: 'dh-btn-prefix' },
        _react2.default.createElement(_icon2.default, { type: icon })
      ) : null,
      icon && shape ? _react2.default.createElement(
        'span',
        null,
        _react2.default.createElement(_icon2.default, { type: icon })
      ) : _react2.default.createElement(
        'span',
        null,
        this.props.children
      )
    );
  };

  return Button;
}(_react2.default.Component);

Button.defaultProps = {
  htmlType: 'button'
};
Button.propTypes = {
  htmlType: _propTypes2.default.oneOf(['button', 'submit']),
  type: _propTypes2.default.oneOf(['success', 'primary', 'info', 'warning', 'danger', 'default']),
  size: _propTypes2.default.oneOf(['small']),
  shape: _propTypes2.default.oneOf(['circle']),
  icon: _propTypes2.default.string,
  onClick: _propTypes2.default.func,
  ghost: _propTypes2.default.bool,
  className: _propTypes2.default.string
};
exports.default = Button;