'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _createReactClass = require('create-react-class');

var _createReactClass2 = _interopRequireDefault(_createReactClass);

var _rcForm = require('rc-form');

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _formItem = require('./form-item');

var _formItem2 = _interopRequireDefault(_formItem);

var _constants = require('./constants');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Form = function (_React$Component) {
  _inherits(Form, _React$Component);

  function Form(props) {
    _classCallCheck(this, Form);

    return _possibleConstructorReturn(this, _React$Component.call(this, props));
  }

  // if create
  Form.create = function create(options) {
    var formWrapper = (0, _rcForm.createForm)(Object.assign({
      fieldNameProp: 'id'
    }, options, {
      fieldMetaProp: _constants.FIELD_META_PROP
    }));
    return function (Component) {
      return formWrapper((0, _createReactClass2.default)({
        propTypes: {
          form: _propTypes2.default.object.isRequired
        },
        childContextTypes: {
          form: _propTypes2.default.object.isRequired
        },
        getChildContext: function getChildContext() {
          return {
            form: this.props.form
          };
        },
        componentWillMount: function componentWillMount() {
          this.__getFieldProps = this.props.form.getFieldProps;
        },
        deprecatedGetFieldProps: function deprecatedGetFieldProps(name, option) {
          warning(false, '`getFieldProps` is not recommended, please use `getFieldDecorator` instead, ' + 'see: https://github.com/react-component/form');
          return this.__getFieldProps(name, option);
        },
        render: function render() {
          'wjb-test', this.deprecatedGetFieldProps;
          this.props.form.getFieldProps = this.deprecatedGetFieldProps;

          var withRef = {};
          if (options && options.withRef) {
            withRef.ref = 'formWrappedComponent';
          }
          return _react2.default.createElement(Component, _extends({}, this.props, withRef));
        }
      }));
    };
  };

  Form.prototype.render = function render() {
    var _classNames;

    var _props = this.props,
        layout = _props.layout,
        props = _objectWithoutProperties(_props, ['layout']);

    return _react2.default.createElement(
      'form',
      _extends({}, props, {
        className: (0, _classnames2.default)('dh-form', (_classNames = {}, _classNames['dh-form-' + layout] = layout, _classNames)) }),
      this.props.children
    );
  };

  return Form;
}(_react2.default.Component);

Form.defaultProps = {
  layout: 'horizontal',
  onSubmit: function onSubmit(e) {
    e.preventDefault();
  }
};
Form.propTypes = {
  layout: _propTypes2.default.oneOf(['horizontal', 'inline', 'vertical']),
  children: _propTypes2.default.any,
  onSubmit: _propTypes2.default.func
};
Form.Item = _formItem2.default;
exports.default = Form;