'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _icon = require('../icon');

var _icon2 = _interopRequireDefault(_icon);

var _number = require('./number');

var _number2 = _interopRequireDefault(_number);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Input = function (_React$Component) {
  _inherits(Input, _React$Component);

  function Input(props) {
    _classCallCheck(this, Input);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _this.state = {
      focus: false
    };
    _this.handleBlur = _this.handleBlur.bind(_this);
    _this.handleFocus = _this.handleFocus.bind(_this);
    return _this;
  }
  // componentWillMount() {
  //   if (this.props.value) {
  //     this.state.value = this.props.value;
  //   }
  // }
  // componentWillReceiveProps(nextProps) {
  //   if (this.props.value !== nextProps.value) {
  //     this.state.value = nextProps.value;
  //   }
  // }
  // // shouldComponentUpdate(nextProps, nextState) {
  // //   return !nextProps.value !== nextState.value;
  // // }


  Input.prototype.handleBlur = function handleBlur(e) {
    // this.setState({
    //   focus: false
    // })
    if (this.props.onBlur) {
      this.props.onBlur(e);
    }
  };

  Input.prototype.handleFocus = function handleFocus(e) {
    // this.setState({
    //   focus: true
    // })
    if (this.props.onFocus) {
      this.props.onFocus(e);
    }
  };

  Input.prototype.render = function render() {
    var _props = this.props,
        width = _props.width,
        addonBefore = _props.addonBefore,
        addonAfter = _props.addonAfter,
        searched = _props.searched,
        props = _objectWithoutProperties(_props, ['width', 'addonBefore', 'addonAfter', 'searched']);

    var style = {
      transform: this.state.focus ? 'scaleX(1)' : ' scaleX(0)'
    };
    return _react2.default.createElement(
      'div',
      { className: 'dh-input', style: { width: width } },
      addonBefore && searched === false ? _react2.default.createElement(
        'div',
        { className: 'dh-input-before' },
        this.props.addonBefore
      ) : null,
      searched ? _react2.default.createElement(
        'div',
        { className: (0, _classnames2.default)('dh-input-before', {
            'dh-input-search': searched
          }) },
        _react2.default.createElement(_icon2.default, { type: 'search' })
      ) : null,
      _react2.default.createElement(
        'div',
        { className: 'dh-input-warp' },
        _react2.default.createElement('input', _extends({}, props, {
          className: 'dh-input-warp-inner',
          onFocus: this.handleFocus,
          onBlur: this.handleBlur
        }))
      ),
      addonAfter ? _react2.default.createElement(
        'div',
        { className: 'dh-input-after' },
        this.props.addonAfter
      ) : null,
      _react2.default.createElement('div', {
        style: style,
        className: 'dh-input-bordered' })
    );
  };

  return Input;
}(_react2.default.Component);

Input.Number = _number2.default;
Input.defaultProps = {
  placeholder: '',
  searched: false
};
Input.propsTypes = {
  width: _propTypes2.default.oneOfType([_propTypes2.default.number, _propTypes2.default.string]),
  placeholder: _propTypes2.default.string,
  name: _propTypes2.default.string,
  value: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]),
  disabled: _propTypes2.default.bool,
  addonBefore: _propTypes2.default.oneOfType([_propTypes2.default.element]),
  addonAfter: _propTypes2.default.oneOfType([_propTypes2.default.element]),
  searched: _propTypes2.default.bool,
  danger: _propTypes2.default.bool
};
exports.default = Input;