'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _rcInputNumber = require('rc-input-number');

var _rcInputNumber2 = _interopRequireDefault(_rcInputNumber);

var _index = require('../index');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Number = function (_React$Component) {
  _inherits(Number, _React$Component);

  function Number(props) {
    _classCallCheck(this, Number);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _this.state = {
      focus: false
    };
    _this.handleFocus = _this.handleFocus.bind(_this);
    _this.handleBlur = _this.handleBlur.bind(_this);
    return _this;
  }

  Number.prototype.handleFocus = function handleFocus() {
    this.setState({ focus: true });
  };

  Number.prototype.handleBlur = function handleBlur(e) {
    this.setState({ focus: false });
    if (this.props.onBlur) {
      this.props.onBlur(e);
    }
  };

  Number.prototype.render = function render() {
    var width = this.props.width;

    var style = {
      transform: this.state.focus ? 'scaleX(1)' : ' scaleX(0)'
    };
    return _react2.default.createElement(
      'div',
      {
        style: { width: width },
        className: 'dh-input' },
      _react2.default.createElement(_rcInputNumber2.default, _extends({}, this.props, {
        prefixCls: 'dh-input-number',
        upHandler: _react2.default.createElement(_index.Icon, { type: 'up' }),
        downHandler: _react2.default.createElement(_index.Icon, { type: 'down' }),
        onFocus: this.handleFocus,
        onBlur: this.handleBlur
      })),
      _react2.default.createElement('div', {
        style: style,
        className: 'dh-input-bordered'
      })
    );
  };

  return Number;
}(_react2.default.Component);

Number.propTypes = {
  width: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]),
  placeholder: _propTypes2.default.string,
  onChange: _propTypes2.default.func,
  onBlur: _propTypes2.default.func
};
exports.default = Number;