'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _rcMenu = require('rc-menu');

var _rcMenu2 = _interopRequireDefault(_rcMenu);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _cssAnimation = require('css-animation');

var _cssAnimation2 = _interopRequireDefault(_cssAnimation);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var prefixCls = 'dh-menu';

var Menu = function (_React$Component) {
  _inherits(Menu, _React$Component);

  function Menu(props) {
    _classCallCheck(this, Menu);

    return _possibleConstructorReturn(this, _React$Component.call(this, props));
  }

  Menu.prototype.animate = function animate(node, show, done) {
    var height = void 0;
    return (0, _cssAnimation2.default)(node, prefixCls + '-collapse', {
      start: function start() {
        if (!show) {
          node.style.height = node.offsetHeight + 'px';
          node.style.opacity = 0;
        } else {
          height = node.offsetHeight;
          node.style.height = 0;
          node.style.opacity = 1;
          // node.style.transform = 'translate(-10px, 0)';
        }
      },
      active: function active() {
        node.style.height = (show ? height : 0) + 'px';
        // node.style.transform = `translate(${show ? '0' : '-10px'}, 0)`;
      },
      end: function end() {
        node.style.height = '';
        done();
      }
    });
  };

  Menu.prototype.render = function render() {
    var _this = this;
    var openAnimation = {
      enter: function enter(node, done) {
        return _this.animate(node, true, done);
      },
      appear: function appear(node, done) {
        return _this.animate(node, true, done);
      },
      leave: function leave(node, done) {
        return _this.animate(node, false, done);
      }
    };
    var props = this.props.mode === 'inline' ? _extends({}, this.props, { openAnimation: openAnimation }) : this.props;
    return _react2.default.createElement(_rcMenu2.default, _extends({
      prefixCls: prefixCls,
      className: (0, _classnames2.default)({
        'dh-menu-border': props.bordered,
        'dh-menu-dark': props.theme === 'dark'
      })
    }, props));
  };

  return Menu;
}(_react2.default.Component);

Menu.SubMenu = _rcMenu.SubMenu;
Menu.Item = _rcMenu.Item;
Menu.Divider = _rcMenu.Divider;
Menu.ItemGroup = _rcMenu.ItemGroup;
Menu.defaultProps = {
  bordered: true
};
Menu.propTypes = {
  bordered: _propTypes2.default.bool
};
exports.default = Menu;