'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _rcDialog = require('rc-dialog');

var _rcDialog2 = _interopRequireDefault(_rcDialog);

var _addEventListener = require('rc-util/lib/Dom/addEventListener');

var _addEventListener2 = _interopRequireDefault(_addEventListener);

var _is_js = require('is_js');

var _is_js2 = _interopRequireDefault(_is_js);

var _button = require('../button');

var _button2 = _interopRequireDefault(_button);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var mousePosition = void 0;
var mousePositionEventBinded = void 0;

var Modal = function (_React$Component) {
  _inherits(Modal, _React$Component);

  function Modal(props) {
    _classCallCheck(this, Modal);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _this.handleCancel = _this.handleCancel.bind(_this);
    _this.handleOk = _this.handleOk.bind(_this);
    return _this;
  }

  Modal.prototype.componentDidMount = function componentDidMount() {
    this.setMousePosition();
  };

  Modal.prototype.setMousePosition = function setMousePosition() {
    if (mousePositionEventBinded) {
      return;
    }
    // 只有点击事件支持从鼠标位置动画展开
    (0, _addEventListener2.default)(document.documentElement, 'click', function (e) {
      mousePosition = {
        x: e.pageX,
        y: e.pageY
      };
      // 100ms 内发生过点击事件，则从点击位置动画展示
      // 否则直接 zoom 展示
      // 这样可以兼容非点击方式展开
      setTimeout(function () {
        return mousePosition = null;
      }, 100);
    });
    mousePositionEventBinded = true;
  };

  Modal.prototype.handleCancel = function handleCancel() {
    if (this.props.onCancel) {
      this.props.onCancel();
    }
  };

  Modal.prototype.handleOk = function handleOk() {
    if (this.props.onOk) {
      this.props.onOk();
    }
  };

  Modal.prototype.renderFooter = function renderFooter() {
    var _props = this.props,
        cancelText = _props.cancelText,
        okText = _props.okText,
        footer = _props.footer;

    if (_is_js2.default.object(footer)) return footer; //element类型 直接返回
    var buttonOk = _react2.default.createElement(
      'button',
      {
        key: 'ok',
        onClick: this.handleOk,
        className: 'dh-modal-footer_btn'
      },
      okText
    );
    var buttonCancel = _react2.default.createElement(
      'button',
      {
        key: 'cancel',
        onClick: this.handleCancel,
        className: 'dh-modal-footer_btn'
      },
      cancelText
    );
    return [buttonOk, buttonCancel];
  };

  Modal.prototype.renderTitle = function renderTitle() {
    var _props2 = this.props,
        title = _props2.title,
        desc = _props2.desc,
        footer = _props2.footer;

    var titleElement = title ? _react2.default.createElement(
      'div',
      { key: 'title', className: 'dh-modal-title__label' },
      title
    ) : null;
    var descElement = desc ? _react2.default.createElement(
      'div',
      { key: 'desc', className: 'dh-modal-title__desc' },
      desc
    ) : null;
    return [titleElement, descElement];
  };

  Modal.prototype.render = function render() {
    var _props3 = this.props,
        footer = _props3.footer,
        confirmLoading = _props3.confirmLoading,
        props = _objectWithoutProperties(_props3, ['footer', 'confirmLoading']);

    return _react2.default.createElement(_rcDialog2.default, _extends({
      prefixCls: 'dh-modal',
      onClose: this.handleCancel
    }, props, {
      footer: _is_js2.default.boolean(footer) && !footer ? null : this.renderFooter(),
      mousePosition: mousePosition
    }));
  };

  return Modal;
}(_react2.default.Component);

Modal.defaultProps = {
  width: 380,
  transitionName: 'zoom',
  maskTransitionName: 'fade',
  confirmLoading: false,
  visible: false,
  okText: '确定',
  cancelText: '取消'
};
Modal.propType = {
  onOk: _propTypes2.default.func,
  onCancel: _propTypes2.default.func,
  okText: _propTypes2.default.string,
  cancelText: _propTypes2.default.string,
  width: _propTypes2.default.oneOfType([_propTypes2.default.number, _propTypes2.default.string]),
  confirmLoading: _propTypes2.default.bool,
  footer: _propTypes2.default.oneOfType([_propTypes2.default.element, _propTypes2.default.bool]),
  title: _propTypes2.default.node, //sting: 主标题；
  desc: _propTypes2.default.string // 描述信息
};
exports.default = Modal;