'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Group = function (_Component) {
  _inherits(Group, _Component);

  function Group(props) {
    _classCallCheck(this, Group);

    var _this = _possibleConstructorReturn(this, _Component.call(this, props));

    _this.state = {
      checked: props.defaultSelectKey
    };
    _this.onSelectChange = _this.onSelectChange.bind(_this);
    return _this;
  }

  Group.prototype.onSelectChange = function onSelectChange(checked, key) {
    if (checked && this.state.checked != key) {
      this.setState({
        checked: key
      });
      this.props.onChange(key);
    }
  };

  Group.prototype.render = function render() {
    var _this2 = this;

    var children = this.props.children;
    var checked = this.state.checked;


    return _react2.default.createElement(
      'div',
      null,
      _react2.default.Children.map(children, function (child, i) {
        var key = child.key || i;
        var props = _extends({}, child.props, {
          onChange: function onChange(checked) {
            return _this2.onSelectChange(checked, key);
          },
          checked: checked === key,
          key: key
        });
        return _extends({}, child, { props: props });
      })
    );
  };

  return Group;
}(_react.Component);

Group.propTypes = {
  defaultSelectKey: _propTypes2.default.string,
  onChange: _propTypes2.default.func
};
Group.defaultProps = {
  onChange: function onChange() {}
};
exports.default = Group;