'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _is_js = require('is_js');

var _is_js2 = _interopRequireDefault(_is_js);

var _rcSlider = require('rc-slider');

var _rcSlider2 = _interopRequireDefault(_rcSlider);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _index = require('../index');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var RcRange = _rcSlider.Range;
var RcHandle = _rcSlider.Handle;

var Slider = function (_React$Component) {
  _inherits(Slider, _React$Component);

  function Slider(props) {
    _classCallCheck(this, Slider);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _this.renderHandle = function (value, index) {
      var _this$props = _this.props,
          tipFormatter = _this$props.tipFormatter,
          overlay = _this$props.overlay;

      if (Array.isArray(overlay)) {
        return overlay[index];
      }
      if (overlay) return overlay;
      return tipFormatter ? tipFormatter(value) : '';
    };

    _this.renderPlacement = function (index) {
      var _this$props2 = _this.props,
          range = _this$props2.range,
          placement = _this$props2.placement;

      if (range) {
        if (_is_js2.default.array(placement) && _is_js2.default.not.empty(placement)) {
          return placement[index];
        } else {
          return index == 0 ? 'topLeft' : 'bottomRight';
        }
      } else {
        return _is_js2.default.string(placement) ? placement : 'top';
      }
    };

    _this.handleTooltip = function (_ref) {
      var value = _ref.value,
          dragging = _ref.dragging,
          index = _ref.index,
          restProps = _objectWithoutProperties(_ref, ['value', 'dragging', 'index']);

      var _this$props3 = _this.props,
          trigger = _this$props3.trigger,
          tooltipPrefixCls = _this$props3.tooltipPrefixCls,
          visible = _this$props3.visible,
          auto = _this$props3.auto;

      if (auto) {
        return _react2.default.createElement(
          _index.Tooltip,
          {
            prefixCls: tooltipPrefixCls,
            overlay: _this.renderHandle(value, index),
            placement: _this.renderPlacement(index),
            key: index,
            visible: visible,
            trigger: trigger
          },
          _react2.default.createElement(RcHandle, restProps)
        );
      } else {
        return _react2.default.createElement(
          _index.Tooltip,
          {
            prefixCls: tooltipPrefixCls,
            overlay: _this.renderHandle(value, index),
            placement: _this.renderPlacement(index),
            key: index,
            trigger: trigger
          },
          _react2.default.createElement(RcHandle, restProps)
        );
      }
    };

    return _this;
  }

  Slider.prototype.render = function render() {
    var _props = this.props,
        range = _props.range,
        reverse = _props.reverse,
        restProps = _objectWithoutProperties(_props, ['range', 'reverse']);

    if (range) {
      return _react2.default.createElement(RcRange, _extends({ className: (0, _classnames2.default)({ 'dh-slider-reverse': reverse }) }, restProps, { handle: this.handleTooltip }));
    }
    return _react2.default.createElement(_rcSlider2.default, _extends({ className: (0, _classnames2.default)({ 'dh-slider-reverse': reverse }) }, restProps, { handle: this.handleTooltip }));
  };

  return Slider;
}(_react2.default.Component);

Slider.defaultProps = {
  prefixCls: 'dh-slider',
  tooltipPrefixCls: 'dh-slider-tooltip',
  tipFormatter: function tipFormatter(value) {
    return value.toString();
  }
};
exports.default = Slider;