'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _step = require('./step');

var _step2 = _interopRequireDefault(_step);

var _icon = require('../icon');

var _icon2 = _interopRequireDefault(_icon);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var options = {
  1: 'Finished',
  2: 'Progress',
  3: 'Waiting'
};

var Steps = function (_React$Component) {
  _inherits(Steps, _React$Component);

  function Steps(props) {
    _classCallCheck(this, Steps);

    var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

    _this.state = {
      slide: false,
      overOptions: []
    };
    return _this;
  }

  Steps.prototype.getChildContext = function getChildContext() {
    var _props = this.props,
        children = _props.children,
        lineOption = _props.lineOption,
        headOption = _props.headOption,
        mainOption = _props.mainOption;

    var count = _react2.default.Children.count(children);
    var width = 100 / count + '%';
    return {
      width: width,
      lineOption: lineOption,
      headOption: headOption,
      mainOption: mainOption
    };
  };

  Steps.prototype.componentWillReceiveProps = function componentWillReceiveProps(nextProps) {
    if (nextProps.current) {
      this.state.overOptions.push(nextProps.current);
    }
  };

  Steps.prototype.render = function render() {
    var children = this.props.children;
    var overOptions = this.state.overOptions;

    return _react2.default.createElement(
      'div',
      { className: 'dh-steps' },
      _react2.default.Children.map(children, function (child, index) {
        var status = overOptions.indexOf(index + 1) !== -1 ? 'finish' : 'waiting';
        var props = _extends({
          icon: status === 'finish' ? _react2.default.createElement(_icon2.default, { type: 'ok' }) : index + 5,
          title: index > 2 ? options[3] : options[index + 1],
          status: status
        }, child.props);
        return _extends({}, child, { props: props });
      })
    );
  };

  return Steps;
}(_react2.default.Component);

Steps.Step = _step2.default;
Steps.propTypes = {
  lineOption: _propTypes2.default.shape({
    weight: _propTypes2.default.number,
    color: _propTypes2.default.string,
    transitionColor: _propTypes2.default.string
  }),
  headOption: _propTypes2.default.shape({
    bgColor: _propTypes2.default.string,
    color: _propTypes2.default.string,
    transitionColor: _propTypes2.default.string,
    transitionBgColor: _propTypes2.default.string
  }),
  mainOption: _propTypes2.default.shape({
    color: _propTypes2.default.string,
    transitionColor: _propTypes2.default.string
  })
};
Steps.childContextTypes = {
  width: _propTypes2.default.string.isRequired,
  lineOption: _propTypes2.default.object,
  headOption: _propTypes2.default.object,
  mainOption: _propTypes2.default.object
};
exports.default = Steps;