'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _rcTabs = require('rc-tabs');

var _rcTabs2 = _interopRequireDefault(_rcTabs);

var _TabContent = require('rc-tabs/lib/TabContent');

var _TabContent2 = _interopRequireDefault(_TabContent);

var _ScrollableInkTabBar = require('rc-tabs/lib/ScrollableInkTabBar');

var _ScrollableInkTabBar2 = _interopRequireDefault(_ScrollableInkTabBar);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Tabs = function (_React$Component) {
  _inherits(Tabs, _React$Component);

  function Tabs(props) {
    _classCallCheck(this, Tabs);

    return _possibleConstructorReturn(this, _React$Component.call(this, props));
  }

  Tabs.prototype.render = function render() {
    var _classNames;

    var _props = this.props,
        type = _props.type,
        extraContent = _props.extraContent,
        onTabClick = _props.onTabClick,
        animated = _props.animated,
        props = _objectWithoutProperties(_props, ['type', 'extraContent', 'onTabClick', 'animated']);

    return _react2.default.createElement(_rcTabs2.default, _extends({}, props, {
      className: (0, _classnames2.default)((_classNames = {}, _classNames['dh-tab-' + type] = type ? true : false, _classNames[props.classname] = !!props.className, _classNames)),
      renderTabBar: function renderTabBar() {
        return _react2.default.createElement(_ScrollableInkTabBar2.default, {
          extraContent: extraContent,
          onTabClick: onTabClick
        });
      },
      renderTabContent: function renderTabContent() {
        return _react2.default.createElement(_TabContent2.default, { animated: animated });
      },
      tabBarPosition: 'top'
    }));
  };

  return Tabs;
}(_react2.default.Component);

Tabs.defaultProps = Object.assign({}, _rcTabs2.default.defaultProps, {
  prefixCls: 'dh-tab',
  type: 'inline'
});
Tabs.propTypes = {
  type: _propTypes2.default.oneOf(['line', 'diamond']),
  className: _propTypes2.default.string,
  animated: _propTypes2.default.bool
};

Tabs.TabPane = _rcTabs2.default.TabPane;
exports.default = Tabs;